"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }

var _chunk7BEQHGH5cjs = require('./chunk-7BEQHGH5.cjs');


var _chunkVAG3XY63cjs = require('./chunk-VAG3XY63.cjs');


var _chunkLHP7OTMVcjs = require('./chunk-LHP7OTMV.cjs');


var _chunkW3WUDQICcjs = require('./chunk-W3WUDQIC.cjs');

// src/common/data/object-changes.ts
function objectAssignDeepInPlace(toObject, fromObject) {
  if (_chunkVAG3XY63cjs.isRecord.call(void 0, toObject) && _chunkVAG3XY63cjs.isRecord.call(void 0, fromObject)) {
    const fromKeys = Object.keys(fromObject);
    for (const key of _chunkLHP7OTMVcjs.arrayMinus.call(void 0, Object.keys(toObject), fromKeys))
      delete toObject[key];
    for (const key of fromKeys) {
      const from = fromObject[key];
      const to = toObject[key];
      if (_chunkVAG3XY63cjs.isRecord.call(void 0, from)) {
        if (_chunkVAG3XY63cjs.isRecord.call(void 0, to))
          objectAssignDeepInPlace(to, from);
        else
          toObject[key] = _chunkW3WUDQICcjs.cloneObject.call(void 0, from);
      } else if (from !== to) {
        toObject[key] = from;
      }
    }
  }
  return toObject;
}
function objectDescribeChange(fromObject, toObject) {
  const change = {};
  for (const key of _chunkLHP7OTMVcjs.arrayMinus.call(void 0, Object.keys(fromObject), Object.keys(toObject)))
    change[key] = null;
  for (const [key, value] of Object.entries(toObject)) {
    const from = fromObject[key];
    if (_chunkVAG3XY63cjs.isRecord.call(void 0, value)) {
      const subChange = objectDescribeChange(_nullishCoalesce(from, () => ( {})), value);
      if (subChange != null)
        change[key] = subChange;
    } else if (!(value == null && from == null)) {
      if (!_chunk7BEQHGH5cjs.deepEqual.call(void 0, value, from))
        change[key] = value == null ? null : value;
    }
  }
  return Object.keys(change).length > 0 ? change : void 0;
}




exports.objectAssignDeepInPlace = objectAssignDeepInPlace; exports.objectDescribeChange = objectDescribeChange;
//# sourceMappingURL=chunk-SVJWXMAG.cjs.map