"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }// src/common/timeout.ts
function safeTimeout(fn, delay = 0, unref = false) {
  let timerId;
  const disposeTimer = () => {
    clearTimeout(timerId);
    timerId = void 0;
  };
  timerId = setTimeout(() => {
    fn();
    disposeTimer();
  }, delay);
  if (unref)
    _optionalChain([timerId, 'access', _ => _.unref, 'optionalCall', _2 => _2()]);
  return disposeTimer;
}



exports.safeTimeout = safeTimeout;
//# sourceMappingURL=chunk-XTDX3HZA.cjs.map